#include "zcommon.acs"
#library "oneshot"

#include "commonFuncs.h"
#include "oneConst.h"
#include "oneFuncs.h"

script ONESHOT_OPEN open
{
    int weakness = cvarWeakness(), mweakness = cvarMWeakness();
    int owekness, omwekness;

    int gambler = cvarGambler(), gamblerdie = cvarGamblerDie();
    int ogambler, ogamblerdie;

    int currandom, orandom;

    int skill;

    IsServer = 1;

    if (oneshot_cvarinfo())
    {
        if (!GetCVar("oneshot_runbefore"))
        {
            SetHudSize(800, 600, 0);
            HudMessage(s:
"\caWelcome to Oneshot!\
\n
\n\cfoneshot_strength\c- changes the strength of your weapons.\
\n\cfoneshot_weakness\c- changes the strength of the enemies.\
\n\cfoneshot_gambler\c- will make it so if you get hit and a die rolls 1, you get instagibbed!\
\n\cfoneshot_gamblerdie\c- controls how many sides that die has.\
\n\
\n\cfoneshot_hudx\c- controls the X position of the overlay; every 100 moves it 10% to the right.\
\n\cfoneshot_hudy\c- controls the Y position of the hud similarly.\
\n\cfoneshot_hidehud\c- hides the overlay altogether.";
            HUDMSG_FADEOUT | HUDMSG_LOG, 15650, CR_WHITE, 400.0, 200.0, 5.0, 0.5);

            SetCVar("oneshot_runbefore", 1);
        }
    }
    else if (GetCVar("oneshot_weakness") == 0)
    {
        Log(s:"Defaulting to Sudden Death mode");
        Log(s:"Put in \"cvarlist oneshot_*\" to see the variables in Oneshot");
        oneshot_save("oneshot_weakness",     WEAKNESS_COUNT);
        oneshot_save("oneshot_strength",     MWEAKNESS_COUNT);
        oneshot_save("oneshot_gambler",      0);
        oneshot_save("oneshot_gamblerdie",   10);
        oneshot_save("oneshot_norandom",     0);
    }

    while (1)
    {
        owekness    = weakness;     weakness    = cvarWeakness();
        omwekness   = mweakness;    mweakness   = cvarMWeakness();
        ogambler    = gambler;      gambler     = !!cvarGambler();
        ogamblerdie = gamblerdie;   gamblerdie  = cvarGamblerDie();
        orandom     = currandom;    currandom   = cvarNoRandom();

        OneshotWeakness     = weakness;
        OneshotMWeakness    = mweakness;
        OneshotGambler      = gambler;
        OneshotGamblerDie   = gamblerdie;
        OneshotNoRandom     = currandom;

        if ((owekness != weakness) || (omwekness != mweakness) ||
            (ogambler != gambler)  || (ogamblerdie != gamblerdie) ||
            (Timer() % 35 == 0))
        {
            updateClients(weakness, mweakness, gambler, gamblerdie, currandom);
        }

        if (weakness != owekness || mweakness != omwekness)
        {
            ShowNewSkill(weakness, mweakness);
        }

        Delay(1);
    }
}

script ONESHOT_OPEN_CLIENT open clientside
{
    int weakness, mweakness, gambler, gamblerdie, norandom;
    int noflash = 1;

    while (1)
    {
        if (OneshotWeakness == -1)
        {
            DrawOneshotBlankHud();
            Delay(1);
            continue;
        }

        if (!noflash)
        {
            if (weakness   != OneshotWeakness)  { FlashWeakness(OneshotWeakness); }
            if (mweakness  != OneshotMWeakness) { FlashMWeakness(OneshotMWeakness); }
            if (norandom   != OneshotNoRandom)  { FlashNoRandom(OneshotNoRandom); }

            if (gambler    != OneshotGambler || (OneshotGambler && (gamblerdie != OneshotGamblerDie)))
                { FlashGambler(OneshotGambler, OneshotGamblerDie); }
        }

        weakness   = OneshotWeakness;
        mweakness  = OneshotMWeakness;
        gambler    = OneshotGambler;
        gamblerdie = OneshotGamblerDie;
        norandom   = OneshotNoRandom;

        DrawOneshotHud(weakness, mweakness, gambler, gamblerdie, norandom);

        noflash = 0;
        Delay(1);
    }
}

script ONESHOT_SETCLIENT1 (int weakness, int mweakness, int norandom) clientside
{
    if (IsServer == 1) { terminate; }
    OneshotWeakness  = weakness;
    OneshotMWeakness = mweakness;
    OneshotNoRandom  = norandom;
}

script ONESHOT_SETCLIENT2 (int gambler, int gamblerdie) clientside
{
    if (IsServer == 1) { terminate; }
    OneshotGambler      = gambler;
    OneshotGamblerDie   = gamblerdie;
}


script ONESHOT_ENTERESPAWN (int respawned)
{
    int pln = PlayerNumber();
    int strength, weakness, effective, roll;

    while (!isDead(0))
    {
        strength = OneshotMWeakness;
        weakness = OneshotWeakness;

        effective = weakness;

        if (OneshotGambler)
        {
            roll = random(1, OneshotGamblerDie);
            if (roll == 1) { effective = WEAKNESS_COUNT-1; }
        }

        setWeakness(effective);
        setStrength(strength);

        if (OneshotNoRandom && !CheckInventory("NoRandomDamage"))
        {
            GiveInventory("NoRandomDamage", 1);
        }
        else if (!OneshotNoRandom && CheckInventory("NoRandomDamage"))
        {
            TakeInventory("NoRandomDamage", 0x7FFFFFFF);
        }

        Delay(1);
    }
}

script ONESHOT_ENTER enter
{
    ACS_ExecuteAlways(ONESHOT_ENTERESPAWN, 0, 0,0,0);
}

script ONESHOT_RESPAWN respawn
{
    ACS_ExecuteAlways(ONESHOT_ENTERESPAWN, 0, 1,0,0);
}

script ONESHOT_DECORATE (int which, int a1, int a2)
{
    int ret = 0;

    switch (which)
    {
      case 0:
        ret = !!OneshotNoRandom;
        break;

      // Used for projectiles and shit
      case 1:
        if (OneshotNoRandom) { ret = (a1 + (a1 * a2)) >> 1; }
        else { ret = random(1, a2) * a1; }
        break;
    }

    SetResultValue(ret);
}
